# User Access Hub

The [User Access Hub](https://www.useraccesshub.com/) is a service that allows administrators to manage users, user access, and roles across a network of CMS sites and will significantly simplify the administrative tasks associated with managing multiple websites.

[Create a free account to get started](https://www.useraccesshub.com/sign-up).

For a full description of the module, visit the [project page](https://www.drupal.org/project/useraccesshub).

Submit bug reports and feature suggestions, or track changes in the [issue queue](https://www.drupal.org/project/issues/useraccesshub).

## Table of contents

- Requirements
- Recommended modules
- Installation
- Configuration
- Maintainers

## Requirements

- This module requires the openssl_verify() PHP function, which is part of the [OpenSSL library](https://www.php.net/manual/en/book.openssl.php) for PHP.

- This module requires an account on [User Access Hub](https://www.useraccesshub.com/).

## Recommended modules

- [Markdown filter](https://www.drupal.org/project/markdown): When enabled, display of the project's README.md help will be rendered with markdown.
- [Config override warn](https://www.drupal.org/project/config_override_warn): When enabled, allows notification of overriden config values (in one of the settings.php files) in non-production environments.

## Installation

Install as you would normally install a contributed Drupal module. For further information, see [Installing Drupal Modules](https://www.drupal.org/docs/7/extend/installing-modules).

## Configuration

1. Enable the module at Administration > Extend. This will create an API key at Configuration > User Access Hub > Authentication. None of the fields on this form can be edited through the UI. The 'Enable the Handshake Endpoint' checkbox should be checked.
1. Select the roles that should be handled by the hub's SSO functionality at Configuration > User Access Hub > Roles. Select the default role.
1. Add the site to the [User Access Hub](https://www.useraccesshub.com/) hub, setting the API key that was generated from step 1.
1. In the hub, use the 'Connect' operation to allow the hub to handshake with the site. Once this is complete, settings on Configuration > User Access Hub > Authentication will be updated - 'Public Key' will be populated, 'Site ID' will be populated and the 'Enable the Handshake Endpoint' checkbox will be unchecked.
1. To enable all User Access Hub functionality, the final step is to check the 'Enable all of the User Access Hub functionality.' checkbox on Configuration > User Access Hub > Settings.

The Drupal core roles of 'Anonymous' is not available on the Configuration > User Access Hub > Roles form. Anonymous users do not need to login. User Access Hub is meant to be used with defined site roles, however selecting the 'Default' role for a user in the hub will assign the Default role defined by the site to the site user when they login through the User Access Hub. 

## Maintainers

- Scott Joudry - [slydevil](https://www.drupal.org/u/slydevil)
